/*
 * The MIT License
 *
 * Copyright 2016-2020 Charles University
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package cz.cuni.mff.java.cv03;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * Binary search tree (WARNING - unfinished code; the tree is not balanced).
 */
public class SearchTree implements Iterable {

    static private class Node {

        int value;
        Node left;
        Node right;
        Node parent;

        public Node(int v) {
            value = v;
        }
    }

    private Node root;

    public void add(int a) {
        if (root == null) {
            root = new Node(a);
        } else {
            Node n = findPlace(root, a);
            if (n.value != a) {
                if (n.value > a) {
                    n.left = new Node(a);
                    n.left.parent = n;
                } else {
                    n.right = new Node(a);
                    n.right.parent = n;
                }
                // rotations here
            }
        }
    }

    private Node findPlace(Node n, int a) {
        if (n.value == a) {
            return n;
        } else {
            if (n.value > a) {
                if (n.left == null) {
                    return n;
                }
                return findPlace(n.left, a);
            } else {
                if (n.right == null) {
                    return n;
                }
                return findPlace(n.right, a);
            }
        }
    }

    public boolean find(int a) {
        return findInTree(root, a);
    }

    private boolean findInTree(Node n, int a) {
        if (n == null) {
            return false;
        }
        if (n.value == a) {
            return true;
        }
        if (n.value > a) {
            return findInTree(n.left, a);
        } else {
            return findInTree(n.right, a);
        }
    }

    @Override
    public Iterator iterator() {
        return new Iterator() {
            Node next = root;

            { // initializer
                if (next != null) {
                    while (next.left != null) {
                        next = next.left;
                    }
                }
            }

            @Override
            public boolean hasNext() {
                return next != null;
            }

            @Override
            public Object next() {
                if (!hasNext()) {
                    throw new NoSuchElementException();
                }
                Node node = next;
                if (next.right != null) {
                    next = next.right;
                    while (next.left != null) {
                        next = next.left;
                    }
                    return node.value;
                } else {
                    while (true) {
                        if (next.parent == null) {
                            next = null;
                            return node.value;
                        }
                        if (next.parent.left == next) {
                            next = next.parent;
                            return node.value;
                        }
                        next = next.parent;
                    }
                }
            }
        };
    }

    public static void main(String[] args) {
        SearchTree st = new SearchTree();
        st.add(10);
        st.add(15);
        st.add(3);
        st.add(2);
        st.add(8);
        st.add(6);
        st.add(9);
        st.add(12);
        st.add(14);
        st.add(1);
        st.add(4);
        st.add(5);
        st.add(11);
        st.add(7);
        st.add(13);

        for (Object i : st) {
            System.out.println(i);
        }
    }

}
